Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QApplication

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.core.QCoreApplication
                          com.trolltech.qt.gui.QApplication

All Implemented Interfaces:
  QtJambiInterface

    public class QApplication

extends QCoreApplication

The `QApplication` class manages the GUI application's control flow and main settings. It contains the main event loop, where all events from the window system and other sources are processed and dispatched. It also handles the application's initialization and finalization, and provides session management. It also handles most system-wide and application-wide settings.

For any GUI application that uses Qt, there is precisely one `QApplication` object, no matter whether the application has 0, 1, 2 or more windows at any time. For non-GUI Qt applications, use `QCoreApplication` instead, which doesn't depend on the QtGui library.

The `QApplication` object is accessible through the `instance()` function which return a pointer equivalent to the global qApp pointer.

`QApplication`'s main areas of responsibility are:

- It initializes the application with the user's desktop settings such as `palette()`, `font()` and `doubleClickInterval()`. It keeps track of these properties in case the user changes the desktop globally, for example through some kind of control panel.
- It performs event handling, meaning that it receives events from the underlying window system and dispatches them to the relevant widgets. By using `sendEvent()` and `postEvent()` you can send your own events to widgets.
- It parses common command line arguments and sets its internal state accordingly. See the constructor documentation below for more details about this.
- It defines the application's look and feel, which is encapsulated in a `QStyle` object. This can be changed at runtime with `setStyle()`.
- It specifies how the application is to allocate colors. See `setColorSpec()` for details.
- It provides localization of strings that are visible to the user via `translate()`.
- It provides some magical objects like the `desktop()` and the `clipboard()`.
- It knows about the application's windows. You can ask which widget is at a certain position using `widgetAt()`, get a list of `topLevelWidgets()` and `closeAllWindows()`, etc.
- It manages the application's mouse cursor handling, see `setOverrideCursor()`
- On the X window system, it provides functions to flush and sync the communication stream, see flushX() and `syncX()`.
- It provides support for sophisticated session management. This makes it possible for applications to terminate gracefully when the user logs out, to cancel a shutdown process if termination isn't possible and even to preserve the entire application's state for a future session. See `isSessionRestored()`, `sessionId()` and `commitData()` and `saveState()` for details.

Since the `QApplication` object does so much initialization, it must be created before any other objects related to the user interface are created.

Since it also deals with common command line arguments, it is usually a good idea to create it before any interpretation or modification of `argv` is done in the application itself.

Groups of functions
System settings | `desktopSettingsAware()`, `setDesktopSettingsAware()`, `cursorFlashTime()`, `setCursorFlashTime()`, `doubleClickInterval()`, `setDoubleClickInterval()`, `setKeyboardInputInterval()`, `wheelScrollLines()`, `setWheelScrollLines()`, `palette()`, `setPalette()`, `font()`, `setFont()`, `fontMetrics()`.
Event handling | `exec()`, `processEvents()`, `exit()`, `quit()`. `sendEvent()`, `postEvent()`, `sendPostedEvents()`, `removePostedEvents()`, `hasPendingEvents()`, `notify()`, macEventFilter(), qwsEventFilter(), x11EventFilter(), x11ProcessEvent(), winEventFilter().
GUI Styles | `style()`, `setStyle()`.
Color usage | `colorSpec()`, `setColorSpec()`, qwsSetCustomColors().
Text handling | `installTranslator()`, `removeTranslator()``translate()`.
Widgets | `allWidgets()`, `topLevelWidgets()`, `desktop()`, `activePopupWidget()`, `activeModalWidget()`, `clipboard()`, `focusWidget()`, winFocus(), `activeWindow()`, `widgetAt()`.
Advanced cursor handling | `overrideCursor()`, `setOverrideCursor()`, `restoreOverrideCursor()`.
X Window System synchronization | flushX(), `syncX()`.
Session management | `isSessionRestored()`, `sessionId()`, `commitData()`, `saveState()`.
Miscellaneous | `closeAllWindows()`, `startingUp()`, `closingDown()`, `type()`.

See also:
  `QCoreApplication`, `QAbstractEventDispatcher`, `QEventLoop`, and `QSettings`.

Nested Class Summary
`static class` | `QApplication.ColorSpec` See `setColorSpec()` for full details.
`static class` | `QApplication.Type`

Nested classes/interfaces inherited from class com.trolltech.qt.core.QCoreApplication
`QCoreApplication.Encoding`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary
`QSignalEmitter.Signal1` | `commitDataRequest` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal2` | `focusChanged` This signal takes 2 generic argument(s).
`QSignalEmitter.Signal0` | `lastWindowClosed` This signal is emitted from `QApplication::exec()` when the last visible primary window (i.e.
`QSignalEmitter.Signal1` | `saveStateRequest` This signal takes 1 generic argument(s).

Fields inherited from class com.trolltech.qt.core.QCoreApplication
`aboutToQuit, m_instance, unixSignal`

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QApplication(java.lang.String[] args)` Creates a QApplication with the specified command line arguments.

Method Summary
`static void` | `aboutQt()` Displays a simple message box about Qt.
`static void` | `aboutQtJambi()` Displays a simple message box about Qt Jambi.
`static QWidget` | `activeModalWidget()` Returns the active modal widget.
`static QWidget` | `activePopupWidget()` Returns the active popup widget.
`static QWidget` | `activeWindow()` Returns the application top-level window that has the keyboard input focus, or 0 if no application window has the focus.
`static void` | `alert(QWidget widget)` Causes an alert to be shown for `widget` if the window is not the active window.
`static void` | `alert(QWidget widget, int duration)` Causes an alert to be shown for `widget` if the window is not the active window.
`static java.util.List` | `allWidgets()` Returns a list of all the widgets in the application.
`static void` | `beep()` Sounds the bell, using the default volume and sound.
`static void` | `changeOverrideCursor(QCursor arg__1)` Changes the currently active application override cursor to `cursor`.
`static QClipboard` | `clipboard()` Returns a pointer to the application global clipboard.
`static void` | `closeAllWindows()` Closes all top-level windows.
`static int` | `colorSpec()` Returns the color specification.
`void` | `commitData(QSessionManager sm)` This function deals with session management.
`static int` | `cursorFlashTime()` This property holds the text cursor's flash (blink) time in milliseconds.
`static QDesktopWidget` | `desktop()` Returns the desktop widget (also called the root window).
`static boolean` | `desktopSettingsAware()` Returns true if Qt is set to use the system's standard colors, fonts, etc.
`static int` | `doubleClickInterval()` This property holds the time limit in milliseconds that distinguishes a double click from two consecutive mouse clicks.
`static QWidget` | `focusWidget()` Returns the application widget that has the keyboard input focus, or 0 if no widget in this application has the focus.
`static QFont` | `font()` Returns the default application font.
`static QFont` | `font(QWidget arg__1)` Returns the default font for the `widget`.
`static QFontMetrics` | `fontMetrics()` Returns display (screen) font metrics for the application font.
`static QSize` | `globalStrut()` This property holds the minimum size that any GUI element that the user can interact with should have.
`QInputContext` | `inputContext()` Returns the `QInputContext` instance used by the application.
`static QApplication` | `instance()` Returns the unique QApplication instance.
`static boolean` | `isEffectEnabled(Qt.UIEffect arg__1)` Returns true if `effect` is enabled; otherwise returns false.
`static boolean` | `isLeftToRight()` Returns true if the application's layout direction is `Qt::LeftToRight` ; otherwise returns false.
`static boolean` | `isRightToLeft()` Returns true if the application's layout direction is `Qt::RightToLeft` ; otherwise returns false.
`boolean` | `isSessionRestored()` Returns true if the application has been restored from an earlier session; otherwise returns false.
`static Qt.LayoutDirection` | `keyboardInputDirection()` Returns the current keyboard input direction.
`static int` | `keyboardInputInterval()` This property holds the time limit in milliseconds that distinguishes a key press from two consecutive key presses.
`static QLocale` | `keyboardInputLocale()` Returns the current keyboard input locale.
`static Qt.KeyboardModifiers` | `keyboardModifiers()` Returns the current state of the modifier keys on the keyboard.
`static Qt.LayoutDirection` | `layoutDirection()` This property holds the default layout direction for this application.
`static Qt.MouseButtons` | `mouseButtons()` Returns the current state of the buttons on the mouse.
`static QCursor` | `overrideCursor()` Returns the active application override cursor.
`static QPalette` | `palette()` Returns the application palette.
`static QPalette` | `palette(QWidget arg__1)` If a `widget` is passed, the default palette for the widget's class is returned.
`static boolean` | `quitOnLastWindowClosed()` This property holds whether the application implicitly quits when the last window is closed.
`static void` | `restoreOverrideCursor()` Undoes the last `setOverrideCursor()`.
`void` | `saveState(QSessionManager sm)` This function deals with session management.
`java.lang.String` | `sessionId()` Returns the current session's identifier.
`java.lang.String` | `sessionKey()` Returns the session key in the current session.
`static void` | `setActiveWindow(QWidget act)` Sets the active window to the `active` widget in response to a system event.
`static void` | `setColorSpec(int arg__1)` Sets the color specification for the application to `spec`.
`static void` | `setCursorFlashTime(int arg__1)` This property holds the text cursor's flash (blink) time in milliseconds.
`static void` | `setDesktopSettingsAware(boolean arg__1)` Sets whether Qt should use the system's standard colors, fonts, etc.
`static void` | `setDoubleClickInterval(int arg__1)` This property holds the time limit in milliseconds that distinguishes a double click from two consecutive mouse clicks.
`static void` | `setEffectEnabled(Qt.UIEffect arg__1)` Enables the UI effect `effect` if `enable` is true, otherwise the effect will not be used.
`static void` | `setEffectEnabled(Qt.UIEffect arg__1, boolean enable)` Enables the UI effect `effect` if `enable` is true, otherwise the effect will not be used.
`static void` | `setFont(QFont font)` Changes the default application font to `font`.
`static void` | `setGlobalStrut(QSize arg__1)` This property holds the minimum size that any GUI element that the user can interact with should have.
`void` | `setInputContext(QInputContext arg__1)` This function replaces the `QInputContext` instance used by the application with `inputContext`.
`static void` | `setKeyboardInputInterval(int arg__1)` This property holds the time limit in milliseconds that distinguishes a key press from two consecutive key presses.
`static void` | `setLayoutDirection(Qt.LayoutDirection direction)` This property holds the default layout direction for this application.
`static void` | `setOverrideCursor(QCursor arg__1)` Sets the application override cursor to `cursor`.
`static void` | `setPalette(QPalette palette)` Changes the default application palette to `palette`.
`static void` | `setQuitOnLastWindowClosed(boolean quit)` This property holds whether the application implicitly quits when the last window is closed.
`static void` | `setStartDragDistance(int l)` If you support drag and drop in your application, and want to start a drag and drop operation after the user has moved the cursor a certain distance with a button held down, you should use this property's value as the minimum distance required.
`static void` | `setStartDragTime(int ms)` This property holds the time in milliseconds that a mouse button must be held down before a drag and drop operation will begin.
`static void` | `setStyle(QStyle arg__1)` Sets the application's GUI style to `style`.
`static QStyle` | `setStyle(java.lang.String arg__1)` Requests a `QStyle` object for `style` from the `QStyleFactory`.
`void` | `setStyleSheet(java.lang.String sheet)` This property holds the application style sheet.
`static void` | `setWheelScrollLines(int arg__1)` This property holds the number of lines to scroll a widget, when the mouse wheel is rotated.
`static void` | `setWindowIcon(QIcon icon)` This property holds the default window icon.
`static int` | `startDragDistance()` If you support drag and drop in your application, and want to start a drag and drop operation after the user has moved the cursor a certain distance with a button held down, you should use this property's value as the minimum distance required.
`static int` | `startDragTime()` This property holds the time in milliseconds that a mouse button must be held down before a drag and drop operation will begin.
`static QStyle` | `style()` Returns the application's style object.
`java.lang.String` | `styleSheet()` This property holds the application style sheet.
`static void` | `syncX()` Synchronizes with the X server in the X11 implementation.
`static QWidget` | `topLevelAt(int x, int y)` Returns the top-level widget at the point (`x`, `y`); returns 0 if there is no such widget.
`static QWidget` | `topLevelAt(QPoint p)` Returns the top-level widget at the given `point`; returns 0 if there is no such widget.
`static java.util.List` | `topLevelWidgets()` Returns a list of the top-level widgets (windows) in the application.
`static QApplication.Type` | `type()` Returns the type of application (`Tty` , `GuiClient` , or `GuiServer` ).
`static int` | `wheelScrollLines()` This property holds the number of lines to scroll a widget, when the mouse wheel is rotated.
`static QWidget` | `widgetAt(int x, int y)` Returns the widget at global screen position (`x`, `y`), or 0 if there is no Qt widget there.
`static QWidget` | `widgetAt(QPoint p)` Returns the widget at global screen position `point`, or 0 if there is no Qt widget there.
`static QIcon` | `windowIcon()` This property holds the default window icon.

Methods inherited from class com.trolltech.qt.core.QCoreApplication
`addLibraryPath, applicationDirPath, applicationFilePath, applicationName, applicationPid, applicationVersion, arguments, closingDown, exec, exit, exit, flush, hasPendingEvents, initialize, installTranslator, invokeAndWait, invokeLater, invokeLater, libraryPaths, notify, organizationDomain, organizationName, postEvent, postEvent, processEvents, processEvents, processEvents, processEvents, quit, removeLibraryPath, removePostedEvents, removePostedEvents, removeTranslator, sendEvent, sendPostedEvents, sendPostedEvents, setApplicationName, setApplicationVersion, setAttribute, setAttribute, setLibraryPaths, setOrganizationDomain, setOrganizationName, startingUp, testAttribute, translate, translate, translate`

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### commitDataRequest

    public final QSignalEmitter.Signal1 commitDataRequest

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.gui.QSessionManager(named: manager)>:

  This signal deals with session management. It is emitted when the `QSessionManager` wants the application to commit all its data.

  Usually this means saving all open files, after getting permission from the user. Furthermore you may want to provide a means by which the user can cancel the shutdown.

  Note that you should not exit the application when called. Instead, the session manager may or may not do this afterwards, depending on the context.

  Warning: Within this signal, no user interaction is possible, unless you ask the `manager` for explicit permission. See `QSessionManager::allowsInteraction()` and `QSessionManager::allowsErrorInteraction()` for details and example usage.

  Note: You should use `Qt::DirectConnection` when connecting to this signal.

See also:
  `isSessionRestored()`, `sessionId()`, `saveState()`, and Session Management.

### focusChanged

    public final QSignalEmitter.Signal2 focusChanged

  This signal takes 2 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.gui.QWidget(named: old), com.trolltech.qt.gui.QWidget(named: now)>:

  This signal is emitted when the widget that has keyboard focus changed from `old` to `now`, i. . because the user pressed the tab-key, clicked into a widget or changed the active window. Note that both `old` and `now` can be the null-pointer.

  The signal is emitted after both widget have been notified about the change through `QFocusEvent`.

See also:
  `QWidget::setFocus()`, `QWidget::clearFocus()`, and `Qt::FocusReason` .

### lastWindowClosed

    public final QSignalEmitter.Signal0 lastWindowClosed

  This signal is emitted from `QApplication::exec()` when the last visible primary window (i.e. window with no parent) with the `Qt::WA_QuitOnClose` attribute set is closed.

  By default,

  - this attribute is set for all widgets except transient windows such as splash screens, tool windows, and popup menus
  - `QApplication` implicitly quits when this signal is emitted.
  This feature be turned off by setting `quitOnLastWindowClosed` to false.

See also:
  `QWidget::close()`.

### saveStateRequest

    public final QSignalEmitter.Signal1 saveStateRequest

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.gui.QSessionManager(named: manager)>:

  This signal deals with session management. It is invoked when the `session manager` wants the application to preserve its state for a future session.

  For example, a text editor would create a temporary file that includes the current contents of its edit buffers, the location of the cursor and other aspects of the current editing session.

  Note that you should never exit the application within this signal. Instead, the session manager may or may not do this afterwards, depending on the context. Futhermore, most session managers will very likely request a saved state immediately after the application has been started. This permits the session manager to learn about the application's restart policy.

  Warning: Within this function, no user interaction is possible, unless you ask the `manager` for explicit permission. See `QSessionManager::allowsInteraction()` and `QSessionManager::allowsErrorInteraction()` for details.

  Note:: You should use `Qt::DirectConnection` when connecting to this signal.

See also:
  `isSessionRestored()`, `sessionId()`, `commitData()`, and Session Management.

Constructor Detail

### QApplication

    public QApplication(java.lang.String[] args)

  Creates a QApplication with the specified command line arguments.

Method Detail

### inputContext

    public final QInputContext inputContext()

  Returns the `QInputContext` instance used by the application.

See also:
  `setInputContext()`.

### isSessionRestored

    public final boolean isSessionRestored()

  Returns true if the application has been restored from an earlier session; otherwise returns false.

See also:
  `sessionId()`, `commitData()`, and `saveState()`.

### sessionId

    public final java.lang.String sessionId()

  Returns the current session's identifier.

  If the application has been restored from an earlier session, this identifier is the same as it was in that previous session.

  The session identifier is guaranteed to be unique both for different applications and for different instances of the same application.

See also:
  `isSessionRestored()`, `sessionKey()`, `commitData()`, and `saveState()`.

### sessionKey

    public final java.lang.String sessionKey()

  Returns the session key in the current session.

  If the application has been restored from an earlier session, this key is the same as it was when the previous session ended.

  The session key changes with every call of `commitData()` or `saveState()`.

See also:
  `isSessionRestored()`, `sessionId()`, `commitData()`, and `saveState()`.

### setInputContext

    public final void setInputContext(QInputContext arg__1)

  This function replaces the `QInputContext` instance used by the application with `inputContext`.

See also:
  `inputContext()`.

### setStyleSheet

    public final void setStyleSheet(java.lang.String sheet)

  This property holds the application style sheet. By default, this property returns an empty string unless the user specifies the `-stylesheet` option on the command line when running the application.

See also:
  `QWidget::setStyle()`, and Qt Style Sheets.

### styleSheet

    public final java.lang.String styleSheet()

  This property holds the application style sheet. By default, this property returns an empty string unless the user specifies the `-stylesheet` option on the command line when running the application.

See also:
  `QWidget::setStyle()`, and Qt Style Sheets.

### commitData

    public void commitData(QSessionManager sm)

  This function deals with session management. It is invoked when the `QSessionManager` wants the application to commit all its data.

  Usually this means saving all open files, after getting permission from the user. Furthermore you may want to provide a means by which the user can cancel the shutdown.

  Note that you should not exit the application within this function. Instead, the session manager may or may not do this afterwards, depending on the context.

  Warning: Within this function, no user interaction is possible, unless you ask the `manager` for explicit permission. See `QSessionManager::allowsInteraction()` and `QSessionManager::allowsErrorInteraction()` for details and example usage.

  The default implementation requests interaction and sends a close event to all visible top-level widgets. If any event was rejected, the shutdown is canceled.

See also:
  `isSessionRestored()`, `sessionId()`, `saveState()`, and Session Management.

### saveState

    public void saveState(QSessionManager sm)

  This function deals with session management. It is invoked when the `session manager` wants the application to preserve its state for a future session.

  For example, a text editor would create a temporary file that includes the current contents of its edit buffers, the location of the cursor and other aspects of the current editing session.

  Note that you should never exit the application within this function. Instead, the session manager may or may not do this afterwards, depending on the context. Futhermore, most session managers will very likely request a saved state immediately after the application has been started. This permits the session manager to learn about the application's restart policy.

  Warning: Within this function, no user interaction is possible, unless you ask the `manager` for explicit permission. See `QSessionManager::allowsInteraction()` and `QSessionManager::allowsErrorInteraction()` for details.

See also:
  `isSessionRestored()`, `sessionId()`, `commitData()`, and Session Management.

### aboutQt

    public static void aboutQt()

  Displays a simple message box about Qt. The message includes the version number of Qt being used by the application.

  This is useful for inclusion in the Help menu of an application, as shown in the Menus example.

  This function is a convenience slot for `QMessageBox::aboutQt()`.

### activeModalWidget

    public static QWidget activeModalWidget()

  Returns the active modal widget.

  A modal widget is a special top-level widget which is a subclass of `QDialog` that specifies the modal parameter of the constructor as true. A modal widget must be closed before the user can continue with other parts of the program.

  Modal widgets are organized in a stack. This function returns the active modal widget at the top of the stack.

See also:
  `activePopupWidget()`, and `topLevelWidgets()`.

### activePopupWidget

    public static QWidget activePopupWidget()

  Returns the active popup widget.

  A popup widget is a special top-level widget that sets the `Qt::WType_Popup` widget flag, e.g. the `QMenu` widget. When the application opens a popup widget, all events are sent to the popup. Normal widgets and modal widgets cannot be accessed before the popup widget is closed.

  Only other popup widgets may be opened when a popup widget is shown. The popup widgets are organized in a stack. This function returns the active popup widget at the top of the stack.

See also:
  `activeModalWidget()`, and `topLevelWidgets()`.

### activeWindow

    public static QWidget activeWindow()

  Returns the application top-level window that has the keyboard input focus, or 0 if no application window has the focus. Note that there might be an `activeWindow()` even if there is no `focusWidget()`, for example if no widget in that window accepts key events.

See also:
  `setActiveWindow()`, `QWidget::setFocus()`, `QWidget::hasFocus()`, and `focusWidget()`.

### alert

    public static void alert(QWidget widget)

  Causes an alert to be shown for `widget` if the window is not the active window. The alert is shown for `msec` miliseconds. If `msec` is zero (the default), then the alert is shown indefinitely until the window becomes active again.

  Currently this function does nothing on Qt for Embedded Linux.

  On Mac OS X, this works more at the application level and will cause the application icon to bounce in the dock.

  On Windows this causes the window's taskbar entry to flash for a time. If `msec` is zero, the flashing will stop and the taskbar entry will turn a different color (currently orange).

  On X11, this will cause the window to be marked as "demands attention", the window must not be hidden (i.e. not have hide() called on it, but be visible in some sort of way) in order for this to work.

### alert

    public static void alert(QWidget widget,
                             int duration)

  Causes an alert to be shown for `widget` if the window is not the active window. The alert is shown for `msec` miliseconds. If `msec` is zero (the default), then the alert is shown indefinitely until the window becomes active again.

  Currently this function does nothing on Qt for Embedded Linux.

  On Mac OS X, this works more at the application level and will cause the application icon to bounce in the dock.

  On Windows this causes the window's taskbar entry to flash for a time. If `msec` is zero, the flashing will stop and the taskbar entry will turn a different color (currently orange).

  On X11, this will cause the window to be marked as "demands attention", the window must not be hidden (i.e. not have hide() called on it, but be visible in some sort of way) in order for this to work.

### allWidgets

    public static java.util.List allWidgets()

  Returns a list of all the widgets in the application.

  The list is empty (QList::isEmpty()) if there are no widgets.

  Note that some of the widgets may be hidden.

  Example:

              public final void updateAllWidgets() {
                  for (QWidget widget : QApplication.allWidgets())
                      widget.update();
              }

See also:
  `topLevelWidgets()`, and `QWidget::isVisible()`.

### beep

    public static void beep()

  Sounds the bell, using the default volume and sound. The function is not available in Qt for Embedded Linux.

### changeOverrideCursor

    public static void changeOverrideCursor(QCursor arg__1)

  Changes the currently active application override cursor to `cursor`.

  This function has no effect if `setOverrideCursor()` wasn't called.

See also:
  `setOverrideCursor()`, `overrideCursor()`, `restoreOverrideCursor()`, and `QWidget::setCursor()`.

### clipboard

    public static QClipboard clipboard()

  Returns a pointer to the application global clipboard.

### closeAllWindows

    public static void closeAllWindows()

  Closes all top-level windows.

  This function is particularly useful for applications with many top-level windows. It could, for example, be connected to a Exit entry in the File menu:
  The following code example is written in c++.

          exitAct = new QAction(tr("E&xit"), this);
          exitAct->setShortcut(tr("Ctrl+Q"));
          exitAct->setStatusTip(tr("Exit the application"));
          connect(exitAct, SIGNAL(triggered()), qApp, SLOT(closeAllWindows()));

  The windows are closed in random order, until one window does not accept the close event. The application quits when the last window was successfully closed; this can be turned off by setting `quitOnLastWindowClosed` to false.

See also:
  `quitOnLastWindowClosed`, `lastWindowClosed()` , `QWidget::close()`, `QWidget::closeEvent()`, `lastWindowClosed()` , `quit()`, `topLevelWidgets()`, and `QWidget::isWindow()`.

### colorSpec

    public static int colorSpec()

  Returns the color specification.

See also:
  `QApplication::setColorSpec()`.

### cursorFlashTime

    public static int cursorFlashTime()

  This property holds the text cursor's flash (blink) time in milliseconds. The flash time is the time required to display, invert and restore the caret display. Usually the text cursor is displayed for half the cursor flash time, then hidden for the same amount of time, but this may vary.

  The default value on X11 is 1000 milliseconds. On Windows, the control panel value is used. Widgets should not cache this value since it may be changed at any time by the user changing the global desktop settings.

  Note that on Microsoft Windows, setting this property sets the cursor flash time for all applications.

### desktop

    public static QDesktopWidget desktop()

  Returns the desktop widget (also called the root window).

  Note that the desktop may be composed of multiple screens, so it would be incorrect, for example, to attempt to center some widget in the desktop's geometry. `QDesktopWidget` has various functions for obtaining useful geometries upon the desktop, such as `QDesktopWidget::screenGeometry()` and `QDesktopWidget::availableGeometry()`.

  On X11, it is also possible to draw on the desktop.

### desktopSettingsAware

    public static boolean desktopSettingsAware()

  Returns true if Qt is set to use the system's standard colors, fonts, etc. otherwise returns false. The default is true.

See also:
  `setDesktopSettingsAware()`.

### doubleClickInterval

    public static int doubleClickInterval()

  This property holds the time limit in milliseconds that distinguishes a double click from two consecutive mouse clicks. The default value on X11 is 400 milliseconds. On Windows and Mac OS X, the operating system's value is used.

  On Microsoft Windows, calling this function sets the double click interval for all applications.

### focusWidget

    public static QWidget focusWidget()

  Returns the application widget that has the keyboard input focus, or 0 if no widget in this application has the focus.

See also:
  `QWidget::setFocus()`, `QWidget::hasFocus()`, `activeWindow()`, and `focusChanged()` .

### font

    public static QFont font()

  Returns the default application font.

See also:
  `setFont()`, `fontMetrics()`, and `QWidget::font()`.

### font

    public static QFont font(QWidget arg__1)

  Returns the default font for the `widget`.

See also:
  `fontMetrics()`, and `QWidget::setFont()`.

### fontMetrics

    public static QFontMetrics fontMetrics()

  Returns display (screen) font metrics for the application font.

See also:
  `font()`, `setFont()`, `QWidget::fontMetrics()`, and `QPainter::fontMetrics()`.

### globalStrut

    public static QSize globalStrut()

  This property holds the minimum size that any GUI element that the user can interact with should have. For example, no button should be resized to be smaller than the global strut size. The strut size should be considered when reimplementing GUI controls that may be used on touch-screens or similar I/O devices.

  Example:

              public static QSize sizeHint() {
                  return new QSize(80, 25).expandedTo(QApplication.globalStrut());
              }

  By default, this property contains a `QSize` object with zero width and height.

### isEffectEnabled

    public static boolean isEffectEnabled(Qt.UIEffect arg__1)

  Returns true if `effect` is enabled; otherwise returns false.

  By default, Qt will try to use the desktop settings. Call setDesktopSettingsAware(false) to prevent this.

  Note: All effects are disabled on screens running at less than 16-bit color depth.

See also:
  `setEffectEnabled()`, and `Qt::UIEffect` .

### isLeftToRight

    public static boolean isLeftToRight()

  Returns true if the application's layout direction is `Qt::LeftToRight` ; otherwise returns false.

See also:
  `layoutDirection()`, and `isRightToLeft()`.

### isRightToLeft

    public static boolean isRightToLeft()

  Returns true if the application's layout direction is `Qt::RightToLeft` ; otherwise returns false.

See also:
  `layoutDirection()`, and `isLeftToRight()`.

### keyboardInputDirection

    public static Qt.LayoutDirection keyboardInputDirection()

  Returns the current keyboard input direction.

### keyboardInputInterval

    public static int keyboardInputInterval()

  This property holds the time limit in milliseconds that distinguishes a key press from two consecutive key presses. The default value on X11 is 400 milliseconds. On Windows and Mac OS X, the operating system's value is used.

### keyboardInputLocale

    public static QLocale keyboardInputLocale()

  Returns the current keyboard input locale.

### keyboardModifiers

    public static Qt.KeyboardModifiers keyboardModifiers()

  Returns the current state of the modifier keys on the keyboard. The current state is updated sychronously as the event queue is emptied of events that will spontaneously change the keyboard state (`QEvent::KeyPress` and `QEvent::KeyRelease` events).

  It should be noted this may not reflect the actual keys held on the input device at the time of calling but rather the modifiers as last reported in one of the above events. If no keys are being held `Qt::NoModifier` is returned.

See also:
  `mouseButtons()`.

### layoutDirection

    public static Qt.LayoutDirection layoutDirection()

  This property holds the default layout direction for this application. On system start-up, the default layout direction depends on the application's language.

See also:
  `QWidget::layoutDirection`, `isLeftToRight()`, and `isRightToLeft()`.

### mouseButtons

    public static Qt.MouseButtons mouseButtons()

  Returns the current state of the buttons on the mouse. The current state is updated syncronously as the event queue is emptied of events that will spontaneously change the mouse state (QEvent::MousePress and QEvent::MouseRelease events).

  It should be noted this may not reflect the actual buttons held on theinput device at the time of calling but rather the mouse buttons as last reported in one of the above events. If no mouse buttons are being held `Qt::NoButton` is returned.

See also:
  `keyboardModifiers()`.

### palette

    public static QPalette palette()

  Returns the application palette.

See also:
  `setPalette()`, and `QWidget::palette()`.

### palette

    public static QPalette palette(QWidget arg__1)

  If a `widget` is passed, the default palette for the widget's class is returned. This may or may not be the application palette. In most cases there isn't a special palette for certain types of widgets, but one notable exception is the popup menu under Windows, if the user has defined a special background color for menus in the display settings.

See also:
  `setPalette()`, and `QWidget::palette()`.

### quitOnLastWindowClosed

    public static boolean quitOnLastWindowClosed()

  This property holds whether the application implicitly quits when the last window is closed. The default is true.

  If this property is true, the applications quits when the last visible primary window (i.e. window with no parent) with the `Qt::WA_QuitOnClose` attribute set is closed. By default this attribute is set for all widgets except for sub-windows. Refer to `Qt::WindowType` for a detailed list of `Qt::Window` objects.

See also:
  `quit()`, and `QWidget::close()`.

### restoreOverrideCursor

    public static void restoreOverrideCursor()

  Undoes the last `setOverrideCursor()`.

  If `setOverrideCursor()` has been called twice, calling `restoreOverrideCursor()` will activate the first cursor set. Calling this function a second time restores the original widgets' cursors.

See also:
  `setOverrideCursor()`, and `overrideCursor()`.

### setActiveWindow

    public static void setActiveWindow(QWidget act)

  Sets the active window to the `active` widget in response to a system event. The function is called from the platform specific event handlers.

  Warning: This function does not set the keyboard focus to the active widget. Call `QWidget::activateWindow()` instead.

  It sets the `activeWindow()` and `focusWidget()` attributes and sends proper `WindowActivate` /`WindowDeactivate` and `FocusIn` /`FocusOut` events to all appropriate widgets. The window will then be painted in active state (e.g. cursors in line edits will blink), and it will have tool tips enabled.

See also:
  `activeWindow()`, and `QWidget::activateWindow()`.

### setColorSpec

    public static void setColorSpec(int arg__1)

  Sets the color specification for the application to `spec`.

  The color specification controls how the application allocates colors when run on a display with a limited amount of colors, e.g. 8 bit / 256 color displays.

  The color specification must be set before you create the `QApplication` object.

  The options are:

  - `QApplication::NormalColor` . This is the default color allocation strategy. Use this option if your application uses buttons, menus, texts and pixmaps with few colors. With this option, the application uses system global colors. This works fine for most applications under X11, but on Windows machines it may cause dithering of non-standard colors.
  - `QApplication::CustomColor` . Use this option if your application needs a small number of custom colors. On X11, this option is the same as `NormalColor` . On Windows, Qt creates a Windows palette, and allocates colors to it on demand.
  - `QApplication::ManyColor` . Use this option if your application is very color hungry (e.g. it requires thousands of colors). Under X11 the effect is:
    - For 256-color displays which have at best a 256 color true color visual, the default visual is used, and colors are allocated from a color cube. The color cube is the 6x6x6 (216 color) "Web palette" (the red, green, and blue components always have one of the following values: 0x00, 0x33, 0x66, 0x99, 0xCC, or 0xFF), but the number of colors can be changed by the -ncols option. The user can force the application to use the true color visual with the -visual option.
    - For 256-color displays which have a true color visual with more than 256 colors, use that visual. Silicon Graphics X servers have this feature, for example. They provide an 8 bit visual by default but can deliver true color when asked.
    On Windows, Qt creates a Windows palette, and fills it with a color cube.
  Be aware that the `CustomColor` and `ManyColor` choices may lead to colormap flashing: The foreground application gets (most) of the available colors, while the background windows will look less attractive.

  Example:

              public static void main(String args[]) {
                  QApplication.setColorSpec(QApplication.ColorSpec.ManyColor.value());
                  QApplication.initialize(args);

                   ...
                  QApplication.exec();
              }

See also:
  `colorSpec()`.

### setCursorFlashTime

    public static void setCursorFlashTime(int arg__1)

  This property holds the text cursor's flash (blink) time in milliseconds. The flash time is the time required to display, invert and restore the caret display. Usually the text cursor is displayed for half the cursor flash time, then hidden for the same amount of time, but this may vary.

  The default value on X11 is 1000 milliseconds. On Windows, the control panel value is used. Widgets should not cache this value since it may be changed at any time by the user changing the global desktop settings.

  Note that on Microsoft Windows, setting this property sets the cursor flash time for all applications.

### setDesktopSettingsAware

    public static void setDesktopSettingsAware(boolean arg__1)

  Sets whether Qt should use the system's standard colors, fonts, etc. to `on`. By default, this is true.

  This function must be called before creating the `QApplication` object, like this:

              public static void main(String args[]) {
                  QApplication.setDesktopSettingsAware(false);
                  QApplication.initialize(args);

                   ...

                  QApplication.exec();
              }

See also:
  `desktopSettingsAware()`.

### setDoubleClickInterval

    public static void setDoubleClickInterval(int arg__1)

  This property holds the time limit in milliseconds that distinguishes a double click from two consecutive mouse clicks. The default value on X11 is 400 milliseconds. On Windows and Mac OS X, the operating system's value is used.

  On Microsoft Windows, calling this function sets the double click interval for all applications.

### setEffectEnabled

    public static void setEffectEnabled(Qt.UIEffect arg__1)

  Enables the UI effect `effect` if `enable` is true, otherwise the effect will not be used.

  Note: All effects are disabled on screens running at less than 16-bit color depth.

See also:
  `isEffectEnabled()`, `Qt::UIEffect` , and `setDesktopSettingsAware()`.

### setEffectEnabled

    public static void setEffectEnabled(Qt.UIEffect arg__1,
                                        boolean enable)

  Enables the UI effect `effect` if `enable` is true, otherwise the effect will not be used.

  Note: All effects are disabled on screens running at less than 16-bit color depth.

See also:
  `isEffectEnabled()`, `Qt::UIEffect` , and `setDesktopSettingsAware()`.

### setGlobalStrut

    public static void setGlobalStrut(QSize arg__1)

  This property holds the minimum size that any GUI element that the user can interact with should have. For example, no button should be resized to be smaller than the global strut size. The strut size should be considered when reimplementing GUI controls that may be used on touch-screens or similar I/O devices.

  Example:

              public static QSize sizeHint() {
                  return new QSize(80, 25).expandedTo(QApplication.globalStrut());
              }

  By default, this property contains a `QSize` object with zero width and height.

### setKeyboardInputInterval

    public static void setKeyboardInputInterval(int arg__1)

  This property holds the time limit in milliseconds that distinguishes a key press from two consecutive key presses. The default value on X11 is 400 milliseconds. On Windows and Mac OS X, the operating system's value is used.

### setLayoutDirection

    public static void setLayoutDirection(Qt.LayoutDirection direction)

  This property holds the default layout direction for this application. On system start-up, the default layout direction depends on the application's language.

See also:
  `QWidget::layoutDirection`, `isLeftToRight()`, and `isRightToLeft()`.

### setOverrideCursor

    public static void setOverrideCursor(QCursor arg__1)

  Sets the application override cursor to `cursor`.

  Application override cursors are intended for showing the user that the application is in a special state, for example during an operation that might take some time.

  This cursor will be displayed in all the application's widgets until `restoreOverrideCursor()` or another `setOverrideCursor()` is called.

  Application cursors are stored on an internal stack. `setOverrideCursor()` pushes the cursor onto the stack, and `restoreOverrideCursor()` pops the active cursor off the stack. `changeOverrideCursor()` changes the curently active application override cursor. Every `setOverrideCursor()` must eventually be followed by a corresponding `restoreOverrideCursor()`, otherwise the stack will never be emptied.

  Example:

              QApplication.setOverrideCursor(new QCursor(Qt.CursorShape.WaitCursor));
              calculateHugeMandelbrot();              // lunch time...
              QApplication.restoreOverrideCursor();

See also:
  `overrideCursor()`, `restoreOverrideCursor()`, `changeOverrideCursor()`, and `QWidget::setCursor()`.

### setQuitOnLastWindowClosed

    public static void setQuitOnLastWindowClosed(boolean quit)

  This property holds whether the application implicitly quits when the last window is closed. The default is true.

  If this property is true, the applications quits when the last visible primary window (i.e. window with no parent) with the `Qt::WA_QuitOnClose` attribute set is closed. By default this attribute is set for all widgets except for sub-windows. Refer to `Qt::WindowType` for a detailed list of `Qt::Window` objects.

See also:
  `quit()`, and `QWidget::close()`.

### setStartDragDistance

    public static void setStartDragDistance(int l)

  If you support drag and drop in your application, and want to start a drag and drop operation after the user has moved the cursor a certain distance with a button held down, you should use this property's value as the minimum distance required.

  For example, if the mouse position of the click is stored in `startPos` and the current position (e.g. in the mouse move event) is `currentPos`, you can find out if a drag should be started with code like this:

                  if (startPos.subtract(currentPos).manhattanLength() >=
                      QApplication.startDragDistance()) {
                      startTheDrag();
                  }

  Qt uses this value internally, e.g. in `QFileDialog`.

  The default value is 4 pixels.

See also:
  `startDragTime()`, `QPoint::manhattanLength()`, and Drag and Drop.

### setStartDragTime

    public static void setStartDragTime(int ms)

  This property holds the time in milliseconds that a mouse button must be held down before a drag and drop operation will begin. If you support drag and drop in your application, and want to start a drag and drop operation after the user has held down a mouse button for a certain amount of time, you should use this property's value as the delay.

  Qt also uses this delay internally, e.g. in `QTextEdit` and `QLineEdit`, for starting a drag.

  The default value is 500 ms.

See also:
  `startDragDistance()`, and Drag and Drop.

### setStyle

    public static void setStyle(QStyle arg__1)

  Sets the application's GUI style to `style`. Ownership of the style object is transferred to `QApplication`, so `QApplication` will delete the style object on application exit or when a new style is set and the old style is still the parent of the application object.

  Example usage:

              QApplication.setStyle(new QWindowsStyle());

  When switching application styles, the color palette is set back to the initial colors or the system defaults. This is necessary since certain styles have to adapt the color palette to be fully style-guide compliant.

  Note that setting the style before a palette has been set (i.e. before creating `QApplication`) will cause the application to use `QStyle::standardPalette()` for the palette.

  Warning: Qt style sheets are currently not supported for custom `QStyle` subclasses. We plan to address this in some future release.

See also:
  `style()`, `QStyle`, `setPalette()`, and `desktopSettingsAware()`.

### setStyle

    public static QStyle setStyle(java.lang.String arg__1)

  Requests a `QStyle` object for `style` from the `QStyleFactory`.

  The string must be one of the `QStyleFactory::keys()`, typically one of "windows", "motif", "cde", "plastique", "windowsxp", or "macintosh". Style names are case insensitive.

  Returns 0 if an unknown `style` is passed, otherwise the `QStyle` object returned is set as the application's GUI style.

  Warning: To ensure that the application's style is set correctly, it is best to call this function before the `QApplication` constructor, if possible.

### setWheelScrollLines

    public static void setWheelScrollLines(int arg__1)

  This property holds the number of lines to scroll a widget, when the mouse wheel is rotated. If the value exceeds the widget's number of visible lines, the widget should interpret the scroll operation as a single page up or page down. If the widget is an `item view class`, then the result of scrolling one line depends on the setting of the widget's `scroll mode`. Scroll one line can mean `scroll one item` or `scroll one pixel` .

  By default, this property has a value of 3.

### setWindowIcon

    public static void setWindowIcon(QIcon icon)

  This property holds the default window icon.

See also:
  `QWidget::setWindowIcon()`, and Setting the Application Icon.

### startDragDistance

    public static int startDragDistance()

  If you support drag and drop in your application, and want to start a drag and drop operation after the user has moved the cursor a certain distance with a button held down, you should use this property's value as the minimum distance required.

  For example, if the mouse position of the click is stored in `startPos` and the current position (e.g. in the mouse move event) is `currentPos`, you can find out if a drag should be started with code like this:

                  if (startPos.subtract(currentPos).manhattanLength() >=
                      QApplication.startDragDistance()) {
                      startTheDrag();
                  }

  Qt uses this value internally, e.g. in `QFileDialog`.

  The default value is 4 pixels.

See also:
  `startDragTime()`, `QPoint::manhattanLength()`, and Drag and Drop.

### startDragTime

    public static int startDragTime()

  This property holds the time in milliseconds that a mouse button must be held down before a drag and drop operation will begin. If you support drag and drop in your application, and want to start a drag and drop operation after the user has held down a mouse button for a certain amount of time, you should use this property's value as the delay.

  Qt also uses this delay internally, e.g. in `QTextEdit` and `QLineEdit`, for starting a drag.

  The default value is 500 ms.

See also:
  `startDragDistance()`, and Drag and Drop.

### style

    public static QStyle style()

  Returns the application's style object.

See also:
  `setStyle()`, and `QStyle`.

### syncX

    public static void syncX()

  Synchronizes with the X server in the X11 implementation. This normally takes some time. Does nothing on other platforms.

### topLevelAt

    public static QWidget topLevelAt(QPoint p)

  Returns the top-level widget at the given `point`; returns 0 if there is no such widget.

### topLevelAt

    public static QWidget topLevelAt(int x,
                                     int y)

  Returns the top-level widget at the point (`x`, `y`); returns 0 if there is no such widget.

### topLevelWidgets

    public static java.util.List topLevelWidgets()

  Returns a list of the top-level widgets (windows) in the application.

  Note that some of the top-level widgets may be hidden, for example a tooltip if no tooltip is currently shown.

  Example:

              public final void showAllHiddenTopLevelWidgets() {
                  for (QWidget widget : QApplication.topLevelWidgets()) {
                      if (widget.isHidden())
                          widget.show();
                  }
              }

See also:
  `allWidgets()`, `QWidget::isWindow()`, and `QWidget::isHidden()`.

### type

    public static QApplication.Type type()

  Returns the type of application (`Tty` , `GuiClient` , or `GuiServer` ). The type is set when constructing the `QApplication` object.

### wheelScrollLines

    public static int wheelScrollLines()

  This property holds the number of lines to scroll a widget, when the mouse wheel is rotated. If the value exceeds the widget's number of visible lines, the widget should interpret the scroll operation as a single page up or page down. If the widget is an `item view class`, then the result of scrolling one line depends on the setting of the widget's `scroll mode`. Scroll one line can mean `scroll one item` or `scroll one pixel` .

  By default, this property has a value of 3.

### widgetAt

    public static QWidget widgetAt(QPoint p)

  Returns the widget at global screen position `point`, or 0 if there is no Qt widget there.

  This function can be slow.

See also:
  `QCursor::pos()`, `QWidget::grabMouse()`, and `QWidget::grabKeyboard()`.

### widgetAt

    public static QWidget widgetAt(int x,
                                   int y)

  Returns the widget at global screen position (`x`, `y`), or 0 if there is no Qt widget there.

### windowIcon

    public static QIcon windowIcon()

  This property holds the default window icon.

See also:
  `QWidget::setWindowIcon()`, and Setting the Application Icon.

### aboutQtJambi

    public static void aboutQtJambi()

  Displays a simple message box about Qt Jambi. The message includes the version number of Qt being used by the application.

  This is useful for inclusion in the Help menu of an application.

### instance

    public static QApplication instance()

  Returns the unique QApplication instance.

### setFont

    public static void setFont(QFont font)

  Changes the default application font to `font`.

### setPalette

    public static void setPalette(QPalette palette)

  Changes the default application palette to `palette`.

### overrideCursor

    public static QCursor overrideCursor()

  Returns the active application override cursor.

  This function returns null if no application cursor has been defined (i.e. the internal cursor stack is empty).

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD